-- Einzug (Animation) for Cultivators
-- author  fendtfahrer(95) NKB-Modding
-- finished on 10/04/2013

Einzug = {};

function Einzug.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Cultivator, specializations); 
end;

function Einzug:load(xmlFile) 
    self.heightNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Einzugsparameter#heightNodeIndex"));	
	self.EDura = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.Einzugsparameter#EinzugDuration"),10);
	self.maxD = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.Einzugsparameter#maxDepth"),0.3);
	self.minD = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.Einzugsparameter#minDepth"),0);
	self.cJI = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.Einzugsparameter#componentJointIndex"),1);
	self.ZOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.Einzugsparameter#ZOffset"),0);	
	self.nF = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.Einzugsparameter#normalizeFactor"),0.9);	
	self.posHeight = 0;
	self.negHeight = 0;
end;

function Einzug:delete()
end;

function Einzug:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Einzug:keyEvent(unicode, sym, modifier, isDown)
end;

function Einzug:update(dt)
	
	local _,yHeight,_ = getTranslation(self.heightNode);
	local x,y,z = getWorldTranslation(self.rootNode);
	local length = 0;
	if self.lastWP ~= nil then
		length = Utils.vector2Length(self.lastWP[1]-x , self.lastWP[3]-z);
	end;	
	if self:getIsActive() then
		if self.isClient then
			if self.cultivatorHasGroundContact then
				local loweringAction = self.posHeight;
				self.posHeight = length/self.EDura;
	
				self.posHeight = math.max(self.minD , math.min(self.maxD,self.posHeight));
				if self.movingDirection == 1 and loweringAction ~= self.posHeight then
					setTranslation (self.heightNode, 0, self.posHeight, self.ZOffset) 
					setJointFrame(self.componentJoints[self.cJI].jointIndex, 0, self.componentJoints[self.cJI].jointNode);
				end;
			else
				self.lastWP = {x,y,z};
				if yHeight ~= 0 then
					self.negHeight = yHeight * self.nF
					if self.negHeight < 0.05 and self.negHeight > 0 then
						self.negHeight = 0;
						self.posHeight = 0;
					end;
					setTranslation (self.heightNode, 0, self.negHeight, self.ZOffset)
					setJointFrame(self.componentJoints[self.cJI].jointIndex, 0, self.componentJoints[self.cJI].jointNode);
				end;
			end;
		end;
	end;        		
end;
 
function Einzug:draw()
end;

